Add license headers where missing
[fuel.git] / mcp / scripts / lib.sh
index 3f74058..7449a21 100644 (file)
@@ -1,69 +1,85 @@
 #!/bin/bash
+##############################################################################
+# Copyright (c) 2017 Mirantis Inc., Enea AB and others.
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
 #
 # Library of shell functions
 #
 
-generate_ssh_key() {
+function generate_ssh_key {
+  # shellcheck disable=SC2155
+  local mcp_ssh_key=$(basename "${SSH_KEY}")
   local user=${USER}
   if [ -n "${SUDO_USER}" ] && [ "${SUDO_USER}" != 'root' ]; then
     user=${SUDO_USER}
   fi
 
-  if [ -f "/tmp/${SSH_KEY}" ]; then
-    cp "/tmp/${SSH_KEY}" .
-    ssh-keygen -f "${SSH_KEY}" -y > "${SSH_KEY}.pub"
+  if [ -f "${SSH_KEY}" ]; then
+    cp "${SSH_KEY}" .
+    ssh-keygen -f "${mcp_ssh_key}" -y > "${mcp_ssh_key}.pub"
   fi
 
-  [ -f "${SSH_KEY}" ] || ssh-keygen -f "${SSH_KEY}" -N ''
-  install -o "${user}" -m 0600 "${SSH_KEY}" /tmp/
+  [ -f "${mcp_ssh_key}" ] || ssh-keygen -f "${mcp_ssh_key}" -N ''
+  sudo install -D -o "${user}" -m 0600 "${mcp_ssh_key}" "${SSH_KEY}"
 }
 
-get_base_image() {
+function get_base_image {
   local base_image=$1
+  local image_dir=$2
 
-  mkdir -p images
-  wget -P /tmp -N "${base_image}"
+  mkdir -p "${image_dir}"
+  wget -P "${image_dir}" -N "${base_image}"
 }
 
-cleanup_vms() {
+function cleanup_vms {
   # clean up existing nodes
   for node in $(virsh list --name | grep -P '\w{3}\d{2}'); do
     virsh destroy "${node}"
   done
   for node in $(virsh list --name --all | grep -P '\w{3}\d{2}'); do
-    virsh undefine --nvram "${node}"
+    virsh domblklist "${node}" | awk '/^.da/ {print $2}' | \
+      xargs --no-run-if-empty -I{} sudo rm -f {}
+    virsh undefine "${node}" --remove-all-storage --nvram
   done
 }
 
-prepare_vms() {
+function prepare_vms {
   local -n vnodes=$1
   local base_image=$2
+  local image_dir=$3
 
   cleanup_vms
-  get_base_image "${base_image}"
-  envsubst < user-data.template > user-data.sh
+  get_base_image "${base_image}" "${image_dir}"
+  # shellcheck disable=SC2016
+  envsubst '${SALT_MASTER},${CLUSTER_DOMAIN}' < \
+    user-data.template > user-data.sh
 
   for node in "${vnodes[@]}"; do
     # create/prepare images
-    ./create-config-drive.sh -k "${SSH_KEY}.pub" -u user-data.sh \
-       -h "${node}" "images/mcp_${node}.iso"
-    cp "/tmp/${base_image/*\/}" "images/mcp_${node}.qcow2"
-    qemu-img resize "images/mcp_${node}.qcow2" 100G
+    ./create-config-drive.sh -k "$(basename "${SSH_KEY}").pub" -u user-data.sh \
+       -h "${node}" "${image_dir}/mcp_${node}.iso"
+    cp "${image_dir}/${base_image/*\/}" "${image_dir}/mcp_${node}.qcow2"
+    qemu-img resize "${image_dir}/mcp_${node}.qcow2" 100G
   done
 }
 
-create_networks() {
+function create_networks {
   local -n vnode_networks=$1
   # create required networks, including constant "mcpcontrol"
   # FIXME(alav): since we renamed "pxe" to "mcpcontrol", we need to make sure
   # we delete the old "pxe" virtual network, or it would cause IP conflicts.
-  for net in "pxe" "mcpcontrol" "${vnode_networks[@]}"; do
+  # FIXME(alav): The same applies for "fuel1" virsh network.
+  for net in "fuel1" "pxe" "mcpcontrol" "${vnode_networks[@]}"; do
     if virsh net-info "${net}" >/dev/null 2>&1; then
       virsh net-destroy "${net}" || true
       virsh net-undefine "${net}"
     fi
     # in case of custom network, host should already have the bridge in place
-    if [ -f "net_${net}.xml" ]; then
+    if [ -f "net_${net}.xml" ] && [ ! -d "/sys/class/net/${net}/bridge" ]; then
       virsh net-define "net_${net}.xml"
       virsh net-autostart "${net}"
       virsh net-start "${net}"
@@ -71,11 +87,12 @@ create_networks() {
   done
 }
 
-create_vms() {
+function create_vms {
   local -n vnodes=$1
   local -n vnodes_ram=$2
   local -n vnodes_vcpus=$3
   local -n vnode_networks=$4
+  local image_dir=$5
 
   # AArch64: prepare arch specific arguments
   local virt_extra_args=""
@@ -93,30 +110,27 @@ create_vms() {
       vnode_networks[2]="${vnode_networks[0]}"
     fi
     for net in "${vnode_networks[@]:1}"; do
-      net_type="network"
-      # in case of custom network, host should already have the bridge in place
-      if [ ! -f "net_${net}.xml" ]; then
-        net_type="bridge"
-      fi
-      net_args="${net_args} --network ${net_type}=${net},model=virtio"
+      net_args="${net_args} --network bridge=${net},model=virtio"
     done
 
     # shellcheck disable=SC2086
     virt-install --name "${node}" \
     --ram "${vnodes_ram[$node]}" --vcpus "${vnodes_vcpus[$node]}" \
     --cpu host-passthrough --accelerate ${net_args} \
-    --disk path="$(pwd)/images/mcp_${node}.qcow2",format=qcow2,bus=virtio,cache=none,io=native \
+    --disk path="${image_dir}/mcp_${node}.qcow2",format=qcow2,bus=virtio,cache=none,io=native \
     --os-type linux --os-variant none \
     --boot hd --vnc --console pty --autostart --noreboot \
-    --disk path="$(pwd)/images/mcp_${node}.iso",device=cdrom \
+    --disk path="${image_dir}/mcp_${node}.iso",device=cdrom \
     --noautoconsole \
     ${virt_extra_args}
   done
 }
 
-update_mcpcontrol_network() {
+function update_mcpcontrol_network {
   # set static ip address for salt master node, MaaS node
+  # shellcheck disable=SC2155
   local cmac=$(virsh domiflist cfg01 2>&1| awk '/mcpcontrol/ {print $5; exit}')
+  # shellcheck disable=SC2155
   local amac=$(virsh domiflist mas01 2>&1| awk '/mcpcontrol/ {print $5; exit}')
   virsh net-update "mcpcontrol" add ip-dhcp-host \
     "<host mac='${cmac}' name='cfg01' ip='${SALT_MASTER}'/>" --live
@@ -124,26 +138,26 @@ update_mcpcontrol_network() {
     "<host mac='${amac}' name='mas01' ip='${MAAS_IP}'/>" --live
 }
 
-start_vms() {
+function start_vms {
   local -n vnodes=$1
 
   # start vms
   for node in "${vnodes[@]}"; do
     virsh start "${node}"
-    sleep $[RANDOM%5+1]
+    sleep $((RANDOM%5+1))
   done
 }
 
-check_connection() {
+function check_connection {
   local total_attempts=60
   local sleep_time=5
-  local attempt=1
 
   set +e
   echo '[INFO] Attempting to get into Salt master ...'
 
   # wait until ssh on Salt master is available
-  while ((attempt <= total_attempts)); do
+  # shellcheck disable=SC2034
+  for attempt in $(seq "${total_attempts}"); do
     # shellcheck disable=SC2086
     ssh ${SSH_OPTS} "ubuntu@${SALT_MASTER}" uptime
     case $? in
@@ -151,12 +165,11 @@ check_connection() {
       *) echo "${attempt}/${total_attempts}> ssh server ain't ready yet, waiting for ${sleep_time} seconds ..." ;;
     esac
     sleep $sleep_time
-    ((attempt+=1))
   done
   set -e
 }
 
-parse_yaml() {
+function parse_yaml {
   local prefix=$2
   local s
   local w
@@ -164,7 +177,7 @@ parse_yaml() {
   s='[[:space:]]*'
   w='[a-zA-Z0-9_]*'
   fs="$(echo @|tr @ '\034')"
-  sed -ne "s|^\($s\)\($w\)$s:$s\"\(.*\)\"$s\$|\1$fs\2$fs\3|p" \
+  sed -e 's|---||g' -ne "s|^\($s\)\($w\)$s:$s\"\(.*\)\"$s\$|\1$fs\2$fs\3|p" \
       -e "s|^\($s\)\($w\)$s[:-]$s\(.*\)$s\$|\1$fs\2$fs\3|p" "$1" |
   awk -F"$fs" '{
   indent = length($1)/2;
@@ -176,3 +189,16 @@ parse_yaml() {
       }
   }' | sed 's/_=/+=/g'
 }
+
+function wait_for {
+  local total_attempts=$1; shift
+  local cmdstr=$*
+  local sleep_time=10
+  echo "[NOTE] Waiting for cmd to return success: ${cmdstr}"
+  # shellcheck disable=SC2034
+  for attempt in $(seq "${total_attempts}"); do
+    # shellcheck disable=SC2015
+    eval "${cmdstr}" && break || true
+    echo -n '.'; sleep "${sleep_time}"
+  done
+}